Subject: Re: [PATCH v2] name-hash: don't add sparse directories in threaded lazy init

From: Junio C Hamano <[email-masked]>
Date: Wed, 21 May 2025 13:32:41 -0700

"Alex Mironov via GitGitGadget" <[email-masked]> writes:

> From: Alex Mironov <[email-masked]>
>
> Ensure that logic added in 5f11669586 (name-hash: don't add directories
> to name_hash, 2021-04-12) also applies in multithreaded hashtable init
> path.
>
> Sparse directory entries represent a directory that is outside the
> sparse-checkout definition. These are not paths to blobs, so should not
> be added to the name_hash table as they must never be queried.

The second paragraph sounds as if this is a correctness fix,
i.e. "should not be added" hints that we would see a wrong result
returned from the hashmap if you added these entries to the
name_hash.  If this is a performance-only fix, that should be more
clearly stated.  Also, can we have performance numbers in the
proposed log message as well, or is the improvement too small to
measure?

Thanks.